/* @clake/react-bootstrap4-window v0.1.8 | by Clake
 * Copyright (c) 2019 Clake,
 * 2019-04-26T19:44:48+0800
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _reactBootstrap = require('@clake/react-bootstrap4');

require('./css/CTable.less');

var _Drag = require('./Drag');

var _Drag2 = _interopRequireDefault(_Drag);

var _CTableInput = require('./CTableInput');

var _CTableInput2 = _interopRequireDefault(_CTableInput);

var _CTable = require('./i18n/CTable');

var _CTable2 = _interopRequireDefault(_CTable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CTable = function (_React$Component) {
    _inherits(CTable, _React$Component);

    function CTable(props) {
        _classCallCheck(this, CTable);

        var _this = _possibleConstructorReturn(this, (CTable.__proto__ || Object.getPrototypeOf(CTable)).call(this, props));

        _this.sortHandler = function (e) {
            var dom = e.currentTarget;
            var sort_type = dom.dataset.sort || 'asc';
            _this.changeSort(dom, sort_type);
        };

        _this.scrollHandler = function (e) {
            _this.tableHeader.style.transform = 'translateX(-' + e.currentTarget.scrollLeft + 'px)';
            // this.tableHeader.scrollLeft = e.currentTarget.scrollLeft;
            if (_this.tableTotal) {
                // this.tableTotal.scrollLeft = e.currentTarget.scrollLeft;
                _this.tableTotal.style.transform = 'translateX(-' + e.currentTarget.scrollLeft + 'px)';
            }
        };

        _this.menuContextHandler = function (e) {
            e.preventDefault();
            var data = {
                field: e.target.dataset.field || '',
                data: _this.state.data[e.target.dataset.row],
                index: e.target.dataset.row
            };
            _this.mainMenu.show({ evt: e, type: 'mouse', data: data });
        };

        _this.menuClickHandler = function (field, data) {
            switch (field) {
                case "asc":
                    _this.changeSort(document.querySelector('#' + _this.domId + '-sort-' + data.field), 'asc');
                    break;
                case "desc":
                    _this.changeSort(document.querySelector('#' + _this.domId + '-sort-' + data.field), 'desc');
                    break;
                case "delete_row":
                    _this.deleteRowHandler(parseInt(_this.mainMenu.data.index));
                    break;
            }
        };

        _this.selectPageHandler = function (page) {
            if (typeof _this.props.onSelectPage === 'function') {
                _this.props.onSelectPage(page);
            }
        };

        _this.addNewHandler = function (e) {
            var data = _this.state.data.slice(0);
            data.push(Object.assign({}, _this.cacheRow));
            _this.editRows.push(data.length - 1);
            _this.setState({
                data: data
            }, function () {
                document.querySelector('#' + _this.domId + '-edit').previousElementSibling.querySelector('input:not([disabled])').focus();
            });
        };

        _this.editHandler = function (e, val) {
            var index = parseInt(e.target.dataset.row);
            var field = e.target.dataset.field;
            if (_this.editRows.indexOf(index) === -1) {
                _this.editRows.push(index);
                var data = _this.state.data.slice(0);
                data[index][field] = val;
                _this.setState({ data: data });
            } else {
                _this.state.data[index][field] = val;
            }
        };

        _this.selectAll = function (e) {
            _this.select_all = e.target.checked;
            _reactBootstrap.Common.map(_this.refs, function (item) {
                item.checked = _this.select_all;
            });
        };

        _this.state = {
            data: _this.props.data || [],
            dataCount: _this.props.dataCount,
            page: 1,
            select: _this.props.select,
            total: _this.props.total,
            filter: {
                start: '',
                end: '',
                contain: ''
            }
        };

        _this.originalData = _this.state.data.slice(0);

        _this.domId = 'table-' + _reactBootstrap.Common.RandomString(16);

        _this.select_all = false;
        _this.selectRows = {};

        _this.headerSplits = [];

        _this.sortList = {};
        _this.is_sort = typeof _this.props.onSort === 'function' || _this.props.sort;
        _this.current_sort = null;

        _this.filter_type = null;
        _this.filter_text = null;

        _this.editRows = [];

        _this.initTableWidth();

        _this.cacheRow = {};
        return _this;
    }

    _createClass(CTable, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.bindSplit();
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.state.data !== nextProps.data) {
                this.select_all = false;
                this.selectRows = {};
                if (this.props.edit) {
                    this.editRows = [];
                    this.originalData = _reactBootstrap.Common.Clone(nextProps.data);
                }
                this.setState({
                    data: nextProps.data,
                    dataCount: nextProps.dataCount,
                    page: nextProps.page
                });
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.state.filter !== nextState.filter) {
                return true;
            }
            return nextState.data !== this.state.data;
        }
    }, {
        key: 'initTableWidth',
        value: function initTableWidth() {
            var _this2 = this;

            if (this.props.width) {
                this.width = 0;
                var reg = /(\d+)(px|rem|cm|mm|pt)$/;
                var matchs = this.props.width.match(reg);
                var unit = matchs[2];
                _react2.default.Children.map(this.props.children, function (item, key) {
                    if (item.props.width) {
                        var _matchs = item.props.width.match(reg);
                        _this2.width += parseInt(_matchs[1]);
                    }
                });
                if (this.props.select) {
                    this.width += 20;
                }
                this.width += unit;
            }
        }
    }, {
        key: 'changeHandler',
        value: function changeHandler(row, i) {
            var _this3 = this;

            return function (e) {
                if (e.target.checked) {
                    _this3.selectRows[i] = row;
                } else {
                    _this3.selectRows[i] = undefined;
                }
                if (typeof _this3.props.onCheck === "function") {
                    _this3.props.onCheck(e.target.checked, row);
                }
            };
        }
    }, {
        key: 'clickHandler',
        value: function clickHandler(row, i) {
            var _this4 = this;

            return function () {
                if (typeof _this4.props.onClick === 'function') {
                    _this4.props.onClick(row, i);
                }
            };
        }

        /**
         * sort
         */

    }, {
        key: 'changeSort',
        value: function changeSort(dom, sort_type) {
            if (!dom) {
                return;
            }

            this.clearSort();
            this.current_sort = dom.dataset.field;
            dom.dataset.sort = sort_type === 'asc' ? 'desc' : 'asc';
            dom.classList.remove('ck-ctable-sort');
            this.sortList[dom.dataset.field] = sort_type;
            var child = dom.querySelector('i');
            child.classList.remove('fa-sort', 'fa-sort-alpha-up', 'fa-sort-alpha-down');
            child.classList.add('fa-sort-alpha-' + (sort_type === 'asc' ? 'down' : 'up'));
            if (typeof this.props.onSort === 'function') {
                this.props.onSort(dom.dataset.field, sort_type);
            } else {
                // this.localSort(dom.dataset.field,sort_type)
            }
        }
    }, {
        key: 'clearSort',
        value: function clearSort() {
            if (this.current_sort) {
                var prv = document.querySelector('#' + this.domId + '-sort-' + this.current_sort);
                prv.dataset.sort = 'asc';
                prv.classList.add('ck-ctable-sort');
                var prv_child = prv.querySelector('i');
                prv_child.classList.remove('fa-sort', 'fa-sort-alpha-up', 'fa-sort-alpha-down');
                prv_child.classList.add('fa-sort');
                this.sortList[this.current_sort] = null;
                this.current_sort = null;
            }
        }
    }, {
        key: 'localSort',
        value: function localSort(field, sort_type) {
            var desc = sort_type === 'desc';
            var data = this.originalData.slice(0);
            data.sort(function (a, b) {
                if (a[field] > b[field]) return desc ? -1 : 1;
                if (a[field] < b[field]) return desc ? 1 : -1;
                if (a[field] === b[field]) return 0;
            });
            this.setState({ data: data });
        }

        /**
         * scroll header and total foot
         * @param e
         */

    }, {
        key: 'localFilter',


        /**
         * filter
         * */
        value: function localFilter() {}
    }, {
        key: 'filterHandler',
        value: function filterHandler(text, field, type) {
            this.filter_text = text;
            this.filter_type = type;
            this.filter_field = field;
            if (typeof this.props.onFilter === 'function') {
                this.props.onFilter(text, field, type);
            }
            this.setState({
                filter: {
                    start: '',
                    end: '',
                    contain: ''
                }
            });
            this.mainMenu.hide();
        }
    }, {
        key: 'clearFilter',
        value: function clearFilter() {
            this.filter_text = '';
            this.filter_type = '';
            var field = this.filter_field;
            this.filter_field = '';
            this.clearSort();
            this.setState({
                filter: {
                    start: '',
                    end: '',
                    contain: ''
                }
            });
            if (typeof this.props.onFilter === 'function') {
                this.props.onFilter('', field, 'clear');
            }
        }
    }, {
        key: 'filterChangeHandler',
        value: function filterChangeHandler(field) {
            var _this5 = this;

            return function (val) {
                var filter = _this5.state.filter;
                filter[field] = val;
                _this5.setState({
                    filter: filter
                });
            };
        }

        /**
         * edit mode
         */

    }, {
        key: 'getEditRows',
        value: function getEditRows() {
            var list = [];
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this.editRows[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var row = _step.value;

                    list.push(this.state.data[row]);
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return list;
        }
    }, {
        key: 'deleteRowHandler',
        value: function deleteRowHandler(row_index) {
            if (row_index < 0 || row_index >= this.state.data.length) {
                return;
            }
            if (typeof this.props.onDelete === 'function') {
                this.props.onDelete(this.state.data[row_index], row_index);
            } else {
                this.deleteRow(row_index);
            }
        }
    }, {
        key: 'deleteRow',
        value: function deleteRow(row_index) {
            var _this6 = this;

            if (row_index < 0 || row_index >= this.state.data.length) {
                return;
            }
            var data = this.state.data.slice(0);
            data.splice(row_index, 1);
            if (this.editRows.indexOf(row_index) !== -1) {
                this.editRows.splice(this.editRows.indexOf(row_index), 1);
            }
            this.editRows.forEach(function (item, index) {
                if (item > row_index) {
                    _this6.editRows[index] = item - 1;
                }
            });

            this.setState({ data: data });
        }

        //****************************

    }, {
        key: 'getSelectRows',


        /**
         * 得到所有选中的行
         * @returns {*}
         */
        value: function getSelectRows() {
            return _reactBootstrap.Common.map(this.selectRows, function (item) {
                return item;
            });
        }

        /**
         * 设置选中的行
         * @param key 对应行数据的KEY值
         * @param list 要选中的数据值
         */

    }, {
        key: 'setSelectRows',
        value: function setSelectRows(key, list) {
            var _this7 = this;

            this.state.data.map(function (row, i) {
                if (list.indexOf(row[key]) !== -1) {
                    _this7.refs['row_' + i].setChecked(true);
                }
            });
        }
    }, {
        key: 'bindSplit',
        value: function bindSplit() {
            var _this8 = this;

            if (this.props.move) {
                this.headerSplits.forEach(function (split) {
                    if (!_this8.drag) {
                        _this8.dragColumnLeft = 0;
                        _this8.dragWidth = 0;
                        _this8.drag = new _Drag2.default(_this8.split, split, {
                            start: function start(dragDom, eventDom) {
                                var xy = _reactBootstrap.Common.GetDomXY(eventDom, _this8.mainDom);
                                _this8.dragWidth = parseInt(eventDom.parentNode.style.width);
                                _this8.dragColumnLeft = xy.left - _this8.table_rows.scrollLeft;
                                dragDom.style.left = _this8.dragColumnLeft + 'px';
                                dragDom.classList.remove('d-none');
                                return true;
                            },
                            move: function move(_move, dragDom, eventDom) {
                                if (_this8.dragWidth + (_move.x - _this8.dragColumnLeft) < 50) {
                                    _move.x = _this8.dragColumnLeft - _this8.dragWidth + 50;
                                }
                            },
                            end: function end(dragDom, eventDom) {
                                dragDom.classList.add('d-none');
                                var column_key = eventDom.dataset.key;
                                var diff = parseInt(dragDom.style.left) - _this8.dragColumnLeft;
                                _this8.width = parseInt(_this8.width) + diff + 'px';
                                _this8.table_head.style.width = _this8.width;
                                _this8.table_body.style.width = _this8.width;
                                if (_this8.table_total) {
                                    _this8.table_total.style.width = _this8.width;
                                }
                                document.querySelectorAll('#' + column_key).forEach(function (item) {
                                    item.style.width = _this8.dragWidth + diff + 'px';
                                });
                                return true;
                            }
                        });
                    } else {
                        _this8.drag.setEventDom(split);
                    }
                });
            }
        }
    }, {
        key: 'getClasses',
        value: function getClasses() {
            var base = 'table ck-table';
            //striped
            if (this.props.striped && !this.props.edit) {
                base = (0, _bind2.default)(base, 'table-striped');
            }
            //theme
            if (this.props.theme) {
                base = (0, _bind2.default)(base, 'table-' + this.props.theme);
            }
            //bordered
            if (this.props.bordered) {
                base = (0, _bind2.default)(base, 'table-bordered');
            }
            //hover
            if (this.props.hover) {
                base = (0, _bind2.default)(base, 'table-hover');
            }
            //sm
            if (this.props.sm) {
                base = (0, _bind2.default)(base, 'table-sm');
            }
            if (this.props.fontSm) {
                base = (0, _bind2.default)(base, 'table-font-sm');
            }
            //responsive
            if (this.props.responsive) {
                base = (0, _bind2.default)(base, 'table-responsive');
            }
            //nowrap
            if (this.props.noWrap && !this.props.edit) {
                base = (0, _bind2.default)(base, 'ck-ctable-nowrap');
            }
            return base;
        }
    }, {
        key: 'getMainClasses',
        value: function getMainClasses() {
            var base = 'ck-ctable-main d-flex flex-column';
            if (this.props.bordered) {
                base = (0, _bind2.default)(base, 'border');
            }
            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'getStyles',
        value: function getStyles() {
            //default style
            var base = {};
            //width
            if (this.props.width) {
                base.width = this.props.width;
            }
            //height
            if (this.props.height) {
                base.height = this.props.height;
            }

            if (this.props.absolute) {
                base.position = 'absolute';
                base.top = this.props.y;
                base.left = this.props.x;
                if (_typeof(this.props.position) === 'object') {
                    base.top = this.props.position.top || this.props.y;
                    base.left = this.props.position.left || this.props.x;
                    base.right = this.props.position.right || 'unset';
                    base.bottom = this.props.position.bottom || 'unset';
                    if (this.props.position.left && this.props.position.right) {
                        base.width = 'unset';
                    }
                    if (this.props.position.top && this.props.position.bottom) {
                        base.height = 'unset';
                    }
                }
            }

            return _reactBootstrap.Common.extend(base, this.props.style);
        }
    }, {
        key: 'getHeaderClasses',
        value: function getHeaderClasses() {
            var base = 'ck-ctable-header';
            if (this.props.headerTheme) {
                base = 'thead-' + this.props.headerTheme;
            }
            return (0, _bind2.default)(base, this.props.headClass);
        }
    }, {
        key: 'getTableStyles',
        value: function getTableStyles() {
            var base = {};

            if (this.width) {
                base.width = this.width;
            }

            return base;
        }
    }, {
        key: 'getBodyClasses',
        value: function getBodyClasses() {
            var base = 'ck-ctable-body flex-grow-1 d-flex flex-column';

            return base;
        }
    }, {
        key: 'render',
        value: function render() {
            var _this9 = this;

            return _react2.default.createElement(
                'div',
                { ref: function ref(c) {
                        return _this9.mainDom = c;
                    }, className: this.getMainClasses(), style: this.getStyles() },
                _react2.default.createElement(
                    'div',
                    { className: this.getBodyClasses() },
                    this.renderHeader(),
                    this.renderRows(),
                    this.renderTotal()
                ),
                this.renderFoot(),
                _react2.default.createElement('div', { ref: function ref(c) {
                        return _this9.split = c;
                    }, className: 'ck-split d-none' })
            );
        }
    }, {
        key: 'renderHeader',
        value: function renderHeader() {
            var _this10 = this;

            return _react2.default.createElement(
                'div',
                { ref: function ref(c) {
                        return _this10.tableHeader = c;
                    } },
                _react2.default.createElement(
                    'table',
                    { ref: function ref(c) {
                            return _this10.table_head = c;
                        }, id: 'table-head-' + this.domId, className: this.getClasses(), style: this.getTableStyles() },
                    _react2.default.createElement(
                        'thead',
                        { className: this.getHeaderClasses() },
                        _react2.default.createElement(
                            'tr',
                            null,
                            this.state.select ? _react2.default.createElement(
                                'th',
                                { width: '20px' },
                                this.props.edit ? _react2.default.createElement(_reactBootstrap.Icon, { icon: 'list' }) : _react2.default.createElement('input', { type: 'checkbox', onChange: this.selectAll })
                            ) : null,
                            _react2.default.Children.map(this.props.children, function (item, key) {
                                _this10.cacheRow[item.props.field] = '';
                                if (!item || item.props.hide) {
                                    return null;
                                }
                                // let align = item.props.align || this.props.align;
                                var style = {
                                    'textAlign': 'center'
                                };
                                if (item.props.width) {
                                    style.width = item.props.width;
                                }
                                var sort_icon = 'sort';
                                if (_this10.sortList[item.props.field]) {
                                    sort_icon = 'sort-alpha-' + (_this10.sortList[item.props.field] === 'asc' ? 'down' : 'up');
                                }
                                return _react2.default.createElement(
                                    'th',
                                    { id: _this10.domId + '-' + key, 'data-key': 'head_' + key, style: style },
                                    _this10.is_sort ? _react2.default.createElement(
                                        'a',
                                        { className: 'ck-ctable-sort', href: 'javascript://', id: _this10.domId + '-sort-' + item.props.field,
                                            'data-field': item.props.field,
                                            onClick: _this10.sortHandler },
                                        item.props.text,
                                        ' ',
                                        _react2.default.createElement(_reactBootstrap.Icon, { icon: sort_icon })
                                    ) : item.props.text,
                                    _this10.props.move ? _react2.default.createElement('span', { ref: function ref(c) {
                                            return _this10.headerSplits.push(c);
                                        }, 'data-key': _this10.domId + '-' + key, className: 'ck-column-split' }) : null
                                );
                            })
                        )
                    )
                )
            );
        }
    }, {
        key: 'renderRows',
        value: function renderRows() {
            var _this11 = this;

            return _react2.default.createElement(
                'div',
                { ref: function ref(c) {
                        return _this11.table_rows = c;
                    }, className: 'flex-grow-1 rows', onScroll: this.scrollHandler, onContextMenu: this.menuContextHandler },
                _react2.default.createElement(
                    'table',
                    { ref: function ref(c) {
                            return _this11.table_body = c;
                        }, id: 'table-body-' + this.domId, className: this.getClasses(), style: this.getTableStyles() },
                    _react2.default.createElement(
                        'tbody',
                        null,
                        this.state.data.map(function (row, i) {
                            if (_this11.props.edit) {
                                return _this11.renderEditRow(row, i);
                            }
                            return _this11.renderRow(row, i);
                        }),
                        this.props.edit ? this.renderEditAddRow() : null
                    )
                ),
                this.props.menu ? this.renderMenu() : null
            );
        }
    }, {
        key: 'renderRow',
        value: function renderRow(row, i, parentRow) {
            var _this12 = this;

            return _react2.default.createElement(
                _react2.default.Fragment,
                null,
                _react2.default.createElement(
                    'tr',
                    { className: this.props.onClick ? 'click-row' : null, onClick: this.clickHandler(row, i) },
                    this.state.select ? _react2.default.createElement(
                        'th',
                        { width: '20px' },
                        _react2.default.createElement('input', { type: 'checkbox', ref: 'row_' + i, onChange: this.changeHandler(row, i) })
                    ) : null,
                    _react2.default.Children.map(this.props.children, function (item, key) {
                        if (!item || item.props.hide) {
                            return null;
                        }
                        //set style
                        var style = _extends({}, _this12.props.columnStyle);

                        style.textAlign = item.props.align || _this12.props.align;
                        if (item.props.width) {
                            style.width = item.props.width;
                        }

                        if (item.props.children) {
                            return _react2.default.createElement(
                                'td',
                                { id: _this12.domId + '-' + key, 'data-row': '' + i, 'data-field': item.props.field,
                                    className: item.props.className, style: { 'text-align': align },
                                    key: 'col_' + key },
                                _react2.default.cloneElement(item, {
                                    text: item.props.text,
                                    row: row,
                                    value: row[item.props.field]
                                })
                            );
                        } else {
                            return _react2.default.createElement(
                                'td',
                                { id: _this12.domId + '-' + key,
                                    'data-field': item.props.field,
                                    style: style,
                                    onClick: function onClick(e) {
                                        if (typeof item.props.onClick === 'function') {
                                            item.props.onClick(row);
                                        }
                                    },
                                    onDoubleClick: function onDoubleClick(e) {
                                        if (typeof item.props.onDoubleClick === 'function') {
                                            item.props.onDoubleClick(row);
                                        }
                                    },
                                    'data-row': '' + i },
                                item.props.onFormat ? item.props.onFormat(row[item.props.field], row) : row[item.props.field]
                            );
                        }
                    })
                )
            );
        }
    }, {
        key: 'renderEditRow',
        value: function renderEditRow(row, i) {
            var _this13 = this;

            return _react2.default.createElement(
                _react2.default.Fragment,
                null,
                _react2.default.createElement(
                    'tr',
                    { className: this.props.onClick ? 'click-row' : null, onClick: this.clickHandler(row, i) },
                    this.state.select ? _react2.default.createElement(
                        'th',
                        { width: '20px' },
                        this.editRows.indexOf(i) === -1 ? null : _react2.default.createElement(_reactBootstrap.Icon, { id: this.domId + '-edit-row-icon-' + i, icon: 'edit', className: 'text-danger' })
                    ) : null,
                    _react2.default.Children.map(this.props.children, function (item, key) {
                        if (!item || item.props.hide) {
                            return null;
                        }
                        //set style
                        var style = _extends({}, _this13.props.columnStyle);

                        style.textAlign = item.props.align || _this13.props.align;
                        if (item.props.width) {
                            style.width = item.props.width;
                        }
                        return _react2.default.createElement(
                            'td',
                            { className: item.props.disabled ? 'disabled' : '', id: _this13.domId + '-' + key,
                                'data-field': item.props.field,
                                style: style,
                                onClick: function onClick(e) {
                                    if (typeof item.props.onClick === 'function') {
                                        item.props.onClick(row);
                                    }
                                },
                                onDoubleClick: function onDoubleClick(e) {
                                    if (typeof item.props.onDoubleClick === 'function') {
                                        item.props.onDoubleClick(row);
                                    }
                                },
                                'data-row': '' + i },
                            _this13.renderEditComponent(item.props, row, i)
                        );
                    })
                )
            );
        }
    }, {
        key: 'renderEditAddRow',
        value: function renderEditAddRow() {
            var _this14 = this;

            return _react2.default.createElement(
                'tr',
                { id: this.domId + '-edit' },
                this.state.select ? _react2.default.createElement(
                    'th',
                    { width: '20px' },
                    _react2.default.createElement(_reactBootstrap.Icon, { icon: 'chevron-circle-right' })
                ) : null,
                _react2.default.Children.map(this.props.children, function (item, key) {
                    if (!item || item.props.hide) {
                        return null;
                    }
                    var style = {
                        width: item.props.width
                    };
                    return _react2.default.createElement(
                        'td',
                        { style: style },
                        _react2.default.createElement(_CTableInput2.default, { onFocus: _this14.addNewHandler })
                    );
                })
            );
        }
    }, {
        key: 'renderEditComponent',
        value: function renderEditComponent(item, row, i) {
            switch (item.type) {
                case "combo":
                    return _react2.default.createElement(_CTableInput2.default, { onChange: this.editHandler, 'data-row': i,
                        'data-field': item.field, data: row[item.field],
                        align: item.align, disabled: item.disabled,
                        combo: item.combo, comboData: item.comboData });
                case "calendar":
                    return _react2.default.createElement(_CTableInput2.default, { onChange: this.editHandler, 'data-row': i,
                        'data-field': item.field, data: row[item.field],
                        align: item.align, disabled: item.disabled,
                        calendarFormat: item.calendarFormat, calendar: true });
                case "checkbox":
                    break;
                default:
                    return _react2.default.createElement(_CTableInput2.default, { onChange: this.editHandler, 'data-row': i, 'data-field': item.field, data: row[item.field], align: item.align, disabled: item.disabled });
            }
        }
    }, {
        key: 'renderFoot',
        value: function renderFoot() {
            if (!this.props.foot) {
                return null;
            }
            return _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(_reactBootstrap.Pagination, { current: this.state.page, count: this.state.dataCount, size: 'sm',
                    onSelect: this.selectPageHandler,
                    number: this.props.showNumbers,
                    showPages: this.props.showPages })
            );
        }
    }, {
        key: 'renderTotal',
        value: function renderTotal() {
            var _this15 = this;

            if (!this.state.total) {
                return null;
            }
            var total = this.state.total;
            return _react2.default.createElement(
                'div',
                { ref: function ref(c) {
                        return _this15.tableTotal = c;
                    } },
                _react2.default.createElement(
                    'table',
                    { ref: function ref(c) {
                            return _this15.table_total = c;
                        }, id: 'table-total-' + this.domId, className: this.getClasses(), style: this.getTableStyles() },
                    _react2.default.createElement(
                        'tbody',
                        null,
                        _react2.default.createElement(
                            'tr',
                            null,
                            this.state.select ? _react2.default.createElement(
                                'td',
                                { width: '20px' },
                                _react2.default.createElement(_reactBootstrap.Icon, { icon: 'chart-line' })
                            ) : null,
                            _react2.default.Children.map(this.props.children, function (item, key) {
                                if (!item || item.props.hide) {
                                    return null;
                                }
                                var align = item.props.align || _this15.props.align;
                                var style = {
                                    'textAlign': align
                                };
                                if (item.props.width) {
                                    style.width = item.props.width;
                                }
                                return _react2.default.createElement(
                                    'td',
                                    { id: _this15.domId + '-' + key, 'data-field': item.props.field, style: style },
                                    item.props.onFormat ? item.props.onFormat(total[item.props.field], total) : total[item.props.field]
                                );
                            })
                        )
                    )
                )
            );
        }
    }, {
        key: 'renderMenu',
        value: function renderMenu() {
            var _this16 = this;

            var lang = this.props.lang;
            if (!lang) {
                var i18 = _reactBootstrap.i18n.getLang();
                lang = _CTable2.default[i18.short];
            }
            return _react2.default.createElement(
                _reactBootstrap.Menu,
                { ref: function ref(c) {
                        return _this16.mainMenu = c;
                    }, onClick: this.menuClickHandler },
                _react2.default.createElement(
                    _reactBootstrap.Menu.Item,
                    { field: 'copy', onClick: function onClick() {
                            document.execCommand("copy");
                        } },
                    _react2.default.createElement(_reactBootstrap.Icon, { className: 'mr-1', icon: 'copy' }),
                    lang['Copy']
                ),
                _react2.default.createElement(
                    _reactBootstrap.Menu.Item,
                    { field: 'cut', onClick: function onClick() {
                            document.execCommand("cut");
                        } },
                    _react2.default.createElement(_reactBootstrap.Icon, { className: 'mr-1', icon: 'cut' }),
                    lang['Cut']
                ),
                _react2.default.createElement(_reactBootstrap.Menu.Item, { step: true }),
                _react2.default.createElement(
                    _reactBootstrap.Menu.Item,
                    { field: 'select_filter', onClick: function onClick(e, field, data) {
                            var select = document.getSelection();
                            _this16.filterHandler(select.toString(), data.field, 'contain');
                        } },
                    _react2.default.createElement(_reactBootstrap.Icon, { className: 'mr-1', icon: 'filter' }),
                    lang['Filter By Selection']
                ),
                _react2.default.createElement(
                    _reactBootstrap.Menu.Item,
                    { field: 'clear_filter', onClick: function onClick() {
                            _this16.clearFilter();
                        } },
                    _react2.default.createElement(_reactBootstrap.Icon, { className: 'mr-1', icon: 'brush' }),
                    lang['Clear Filter / Sort']
                ),
                _react2.default.createElement(_reactBootstrap.Menu.Item, { step: true }),
                _react2.default.createElement(
                    _reactBootstrap.Menu.Item,
                    { field: 'filter' },
                    _react2.default.createElement(
                        'span',
                        { className: 'mr-1', style: inputStyle },
                        lang['Start With']
                    ),
                    _react2.default.createElement(_reactBootstrap.Input, { className: 'mr-1', size: 'xs', width: '120px',
                        data: this.state.filter.start,
                        onChange: this.filterChangeHandler('start'),
                        onMouseDown: stopEvent,
                        onEnter: function onEnter() {
                            _this16.filterHandler(_this16.state.filter.start, _this16.mainMenu.data.field, 'start');
                        }
                    }),
                    _react2.default.createElement(_reactBootstrap.Button, { size: 'xs', onMouseDown: stopEvent, onClick: function onClick(e) {
                            _this16.filterHandler(_this16.state.filter.start, _this16.mainMenu.data.field, 'start');
                        }, icon: 'search' })
                ),
                _react2.default.createElement(
                    _reactBootstrap.Menu.Item,
                    { field: 'filter' },
                    _react2.default.createElement(
                        'span',
                        { className: 'mr-1', style: inputStyle },
                        lang['End With']
                    ),
                    _react2.default.createElement(_reactBootstrap.Input, { className: 'mr-1', size: 'xs', width: '120px',
                        data: this.state.filter.end,
                        onChange: this.filterChangeHandler('end'),
                        onMouseDown: stopEvent,
                        onEnter: function onEnter() {
                            _this16.filterHandler(_this16.state.filter.start, _this16.mainMenu.data.field, 'start');
                        }
                    }),
                    _react2.default.createElement(_reactBootstrap.Button, { size: 'xs', onMouseDown: stopEvent, onClick: function onClick(e) {
                            _this16.filterHandler(_this16.state.filter.end, _this16.mainMenu.data.field, 'end');
                        }, icon: 'search' })
                ),
                _react2.default.createElement(
                    _reactBootstrap.Menu.Item,
                    { field: 'filter' },
                    _react2.default.createElement(
                        'span',
                        { className: 'mr-1', style: inputStyle },
                        lang['Contain with']
                    ),
                    _react2.default.createElement(_reactBootstrap.Input, { className: 'mr-1', size: 'xs', width: '120px',
                        data: this.state.filter.contain,
                        onChange: this.filterChangeHandler('contain'),
                        onMouseDown: stopEvent,
                        onEnter: function onEnter() {
                            _this16.filterHandler(_this16.state.filter.start, _this16.mainMenu.data.field, 'start');
                        }
                    }),
                    _react2.default.createElement(_reactBootstrap.Button, { size: 'xs', onMouseDown: stopEvent, onClick: function onClick(e) {
                            _this16.filterHandler(_this16.state.filter.contain, _this16.mainMenu.data.field, 'contain');
                        }, icon: 'search' })
                ),
                this.is_sort ? _react2.default.createElement(_reactBootstrap.Menu.Item, { step: true }) : null,
                this.is_sort ? _react2.default.createElement(
                    _reactBootstrap.Menu.Item,
                    { field: 'asc' },
                    _react2.default.createElement(_reactBootstrap.Icon, { className: 'mr-1', icon: 'sort-alpha-down' }),
                    lang['Sort Ascending']
                ) : null,
                this.is_sort ? _react2.default.createElement(
                    _reactBootstrap.Menu.Item,
                    { field: 'desc' },
                    _react2.default.createElement(_reactBootstrap.Icon, { className: 'mr-1', icon: 'sort-alpha-up' }),
                    lang['Sort Descending']
                ) : null,
                this.props.edit ? _react2.default.createElement(_reactBootstrap.Menu.Item, { step: true }) : null,
                this.props.edit ? _react2.default.createElement(
                    _reactBootstrap.Menu.Item,
                    { field: 'delete_row' },
                    lang['Delete Row']
                ) : null,
                this.props.customMenu ? _react2.default.createElement(_reactBootstrap.Menu.Item, { step: true }) : null,
                this.props.customMenu ? this.props.customMenu.map(function (menu) {
                    return _react2.default.createElement(
                        _reactBootstrap.Menu.Item,
                        { field: menu.field, onClick: menu.click },
                        menu.text
                    );
                }) : null
            );
        }
    }]);

    return CTable;
}(_react2.default.Component);

var inputStyle = { width: '80px' };
var stopEvent = function stopEvent(e) {
    e.stopPropagation();
};

CTable.propTypes = {
    theme: _propTypes2.default.oneOf(['primary', 'secondary', 'success', 'danger', 'warning', 'info', 'light', 'dark']),
    headerTheme: _propTypes2.default.oneOf(['primary', 'secondary', 'success', 'danger', 'warning', 'info', 'light', 'dark']),
    headClass: _propTypes2.default.string,
    data: _propTypes2.default.array,
    dataCount: _propTypes2.default.number,
    page: _propTypes2.default.number,
    select: _propTypes2.default.bool,
    header: _propTypes2.default.bool,
    center: _propTypes2.default.bool,
    currentPage: _propTypes2.default.number,
    striped: _propTypes2.default.bool,
    bordered: _propTypes2.default.bool,
    hover: _propTypes2.default.bool,
    sm: _propTypes2.default.bool,
    fontSm: _propTypes2.default.bool,
    responsive: _propTypes2.default.bool,
    align: _propTypes2.default.string,
    tree: _propTypes2.default.string,
    onClickTree: _propTypes2.default.func,
    onClick: _propTypes2.default.func,
    onCheck: _propTypes2.default.func,
    onFilter: _propTypes2.default.func,
    onSort: _propTypes2.default.func,
    move: _propTypes2.default.bool,
    onRefresh: _propTypes2.default.func,
    refreshText: _propTypes2.default.string,
    absolute: _propTypes2.default.bool,
    x: _propTypes2.default.string,
    y: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    foot: _propTypes2.default.bool,
    position: _propTypes2.default.object,
    showPages: _propTypes2.default.number,
    showNumbers: _propTypes2.default.number,
    onSelectPage: _propTypes2.default.func,
    noWrap: _propTypes2.default.bool,
    menu: _propTypes2.default.bool,
    total: _propTypes2.default.object,
    edit: _propTypes2.default.bool,
    onDelete: _propTypes2.default.func,
    sort: _propTypes2.default.bool,
    filter: _propTypes2.default.bool,
    customMenu: _propTypes2.default.array,
    lang: _propTypes2.default.object
};

CTable.defaultProps = {
    data: [],
    dataCount: 1,
    select: true,
    header: true,
    foot: true,
    currentPage: 1,
    hover: true,
    striped: true,
    align: 'left',
    sm: true,
    fontSm: true,
    headerTheme: 'light',
    noWrap: true,
    bordered: true,
    move: true,
    menu: true
};

exports.default = CTable;
//# sourceMappingURL=CTable.js.map
