/* @clake/react-bootstrap4-window v0.1.8 | by Clake
 * Copyright (c) 2019 Clake,
 * 2019-04-26T19:44:48+0800
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var ReactDOM = _interopRequireWildcard(_reactDom);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _reactBootstrap = require('@clake/react-bootstrap4');

require('./css/WCombo.less');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WCombo = function (_React$PureComponent) {
    _inherits(WCombo, _React$PureComponent);

    function WCombo(props) {
        _classCallCheck(this, WCombo);

        var _this = _possibleConstructorReturn(this, (WCombo.__proto__ || Object.getPrototypeOf(WCombo)).call(this, props));

        _this.hide = function () {
            _this.dom.classList.add('d-none');
        };

        _this.selectHandler = function (val, row) {
            if (typeof _this.props.onSelect === 'function') {
                _this.props.onSelect(val, row, _this.event);
            }
        };

        _this.event = null;
        _this.calDom = null;
        return _this;
    }

    _createClass(WCombo, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.calDom = ReactDOM.findDOMNode(this.combo);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('mousedown', this.hide, false);
        }
    }, {
        key: 'show',
        value: function show(search, e) {
            var xy = _reactBootstrap.Common.GetDomXY(e.currentTarget);
            var fixed = this.calculatePosition(e.currentTarget);
            this.dom.style.left = xy.left - fixed.left + 'px';
            this.dom.style.top = xy.top + xy.height - fixed.top + 5 + 'px';
            this.dom.classList.remove('d-none');
            this.event = e;
            this.combo.show(search, e.currentTarget);
        }
    }, {
        key: 'calculatePosition',
        value: function calculatePosition(e) {
            var scroll = {
                top: e.scrollTop || 0,
                left: e.scrollLeft || 0
            };

            while ((e = e.parentNode) && e !== document.body) {
                if (!e.scrollTop && !e.scrollLeft) continue;
                scroll.top += e.scrollTop;
                scroll.left += e.scrollLeft;
            }
            return scroll;
        }
    }, {
        key: 'filter',
        value: function filter(val) {
            this.combo.filter(val);
        }
    }, {
        key: 'getClasses',
        value: function getClasses() {
            var base = 'ck-wcombo d-none';

            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var content = _react2.default.createElement(
                'div',
                { ref: function ref(c) {
                        return _this2.dom = c;
                    }, className: this.getClasses() },
                _react2.default.createElement(_reactBootstrap.Combo, _extends({ ref: function ref(c) {
                        return _this2.combo = c;
                    } }, this.props.combo, { sm: true,
                    data: this.props.data, noSearch: this.props.noSearch,
                    onSelect: this.selectHandler, onClose: this.hide }))
            );

            var mainDom = document.getElementById('wcombo');
            if (!mainDom) {
                mainDom = document.createElement("DIV");
                mainDom.id = 'wcombo';
                mainDom.className = 'ck-wcombo-container';
                document.body.appendChild(mainDom);
            }

            return ReactDOM.createPortal(content, mainDom);
        }
    }]);

    return WCombo;
}(_react2.default.PureComponent);

WCombo.propTypes = {};

WCombo.defaultProps = {};

exports.default = WCombo;
//# sourceMappingURL=WCombo.js.map
