/* @clake/react-bootstrap4-window v0.1.8 | by Clake
 * Copyright (c) 2019 Clake,
 * 2019-04-26T19:44:48+0800
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _reactBootstrap = require('@clake/react-bootstrap4');

require('./css/WModal.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ModalAlert = 0;
var ModalConfirm = 1;
var ModalLoading = 2;
var ModalView = 3;
var BaseModal = 950;

var WModal = function (_React$Component) {
    _inherits(WModal, _React$Component);

    function WModal(props) {
        _classCallCheck(this, WModal);

        var _this = _possibleConstructorReturn(this, (WModal.__proto__ || Object.getPrototypeOf(WModal)).call(this, props));

        _this.closeHandler = function (e) {
            if (typeof _this.props.onClose === 'function') {
                _this.props.onClose();
            }
        };

        _this.openHandler = function (e) {
            if (typeof _this.props.onOpen === 'function') {
                _this.props.onOpen();
            }
        };

        _this.state = {
            content: '',
            title: '',
            isCloseBtn: true,
            type: ModalAlert,
            center: _this.props.center,
            fade: _this.props.fade,
            show: false,
            header: true
        };
        //modal type
        _this.modalType = ModalAlert;
        //alert confirm callback function
        _this.callback = null;

        _this.domId = 'modal-' + _reactBootstrap.Common.RandomString(16);
        if (_this.props.id) {
            _this.domId = _this.props.id;
        }
        _this.offsetIndex = document.querySelectorAll(".modal").length * 10;
        _this.is_open = false;
        _this.fadeTime = {
            open: 0,
            close: 0
        };
        return _this;
    }

    _createClass(WModal, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            return this.state.content !== nextState.content;
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {}
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {}
    }, {
        key: 'open',
        value: function open() {
            var _this2 = this;

            if (this.is_open) {
                clearTimeout(this.fadeTime.open);
                clearTimeout(this.fadeTime.close);
            }

            this._main.classList.add('d-block');
            this.is_open = true;
            if (this.state.fade) {
                this.fadeTime.open = setTimeout(function () {
                    _this2._shadow.classList.add('modal-show');
                    _this2._dialog.style.opacity = '1';
                    _this2._dialog.style.marginTop = '1.75rem';
                }, 150);
            }
        }
    }, {
        key: 'close',
        value: function close() {
            var _this3 = this;

            if (this.state.fade) {
                this._dialog.style.opacity = '0';
                this._dialog.style.marginTop = '-1rem';
                this._shadow.classList.remove('modal-show');
            }
            this.fadeTime.close = setTimeout(function () {
                _this3._main.classList.remove('d-block');
            }, 150);
            this.is_open = false;
        }
    }, {
        key: 'alert',


        /**
         * modal alert method
         * opt example
         * {
         *      title: '',
         *      content: ''
         *      [,callback: func]
         * }
         * @param opt object
         */
        value: function alert(opt) {
            var _this4 = this;

            this.callback = opt.callback || null;
            this.modalType = ModalAlert;
            this.setState({
                title: opt.title || '提示',
                content: opt.content || opt || '',
                isCloseBtn: true,
                type: ModalAlert,
                center: opt.center || this.props.center,
                fade: opt.fade || this.props.fade,
                header: typeof opt.header === 'undefined' ? true : opt.header
            }, function () {
                _this4.open({
                    backdrop: 'static',
                    keyboard: false
                });
            });
        }

        /**
         * modal confirm method
         * opt example
         * {
         *      title:'',
         *      content:'',
         *      [callback: func]
         * }
         * @param opt
         */

    }, {
        key: 'confirm',
        value: function confirm(opt) {
            var _this5 = this;

            this.callback = opt.callback || null;
            this.modalType = ModalConfirm;
            this.setState({
                title: opt.title || '提示',
                content: opt.content || '',
                isCloseBtn: true,
                type: ModalConfirm,
                center: opt.center || this.props.center,
                fade: opt.fade || this.props.fade,
                header: typeof opt.header === 'undefined' ? true : opt.header
            }, function () {
                _this5.open({
                    backdrop: 'static',
                    keyboard: false
                });
            });
        }

        /**
         * modal loading method
         * @param opt
         */

    }, {
        key: 'loading',
        value: function loading(opt) {
            var _this6 = this;

            this.modalType = ModalLoading;
            this.setState({
                title: opt.title || '提示',
                // content:(
                //     <React.Fragment>
                //         <Icon icon='spinner'/>&nbsp;&nbsp;&nbsp;{content}
                //     </React.Fragment>
                // ),
                content: opt.content || opt || '',
                isCloseBtn: false,
                type: ModalLoading,
                center: opt.center || this.props.center,
                fade: this.props.fade,
                header: opt.header || false
            }, function () {
                _this6.open({
                    backdrop: 'static',
                    keyboard: false
                });
            });
        }

        /**
         * modal view method
         * opt example
         * {
         *      title:'',
         *      content:flex,
         *      [callback:func]
         * }
         * @param opt
         */

    }, {
        key: 'view',
        value: function view(opt) {
            var _this7 = this;

            this.callback = opt.callback || null;
            this.modalType = ModalView;
            this.setState({
                title: opt.title || '提示',
                content: opt.content || '',
                isCloseBtn: true,
                type: ModalView,
                center: opt.center || this.props.center,
                fade: opt.fade || this.props.fade,
                header: typeof opt.header === 'undefined' ? true : opt.header
            }, function () {
                _this7.open({
                    backdrop: 'static',
                    keyboard: false
                });
            });
        }
    }, {
        key: 'getMainClasses',
        value: function getMainClasses() {
            var base = 'wmodal-main';

            if (this.state.fade) {
                base = (0, _bind2.default)(base, 'wmodal-fade');
            }

            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'getClasses',
        value: function getClasses() {
            var base = 'modal wmodal-sm d-block';
            if (this.modalType === ModalView) {
                base = (0, _bind2.default)(base, "bd-example-modal-lg");
            }

            if (this.state.fade) {
                base = (0, _bind2.default)(base, 'wmodal-fade');
            }

            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'getDialogClasses',
        value: function getDialogClasses() {
            var base = 'modal-dialog';
            if (this.modalType === ModalView) {
                base = (0, _bind2.default)(base, "modal-lg");
            }
            if (this.state.center) {
                base = (0, _bind2.default)(base, "modal-dialog-centered");
            }

            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'getShadowClasses',
        value: function getShadowClasses() {
            var base = 'modal-backdrop ck-modal-shadow show';

            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'renderFooter',
        value: function renderFooter() {
            var _this8 = this;

            var content = null;
            switch (this.state.type) {
                case ModalAlert:
                    content = _react2.default.createElement(
                        _reactBootstrap.Button,
                        { size: 'sm', 'data-dismiss': 'modal', onClick: function onClick(e) {
                                _this8.close();
                                if (typeof _this8.callback === 'function') {
                                    _this8.callback(1);
                                }
                            } },
                        '\u786E\u5B9A'
                    );
                    break;
                case ModalConfirm:
                    content = _react2.default.createElement(
                        _react2.default.Fragment,
                        null,
                        _react2.default.createElement(
                            _reactBootstrap.Button,
                            { size: 'sm', onClick: function onClick() {
                                    _this8.close();
                                    if (typeof _this8.callback === 'function') {
                                        _this8.callback(1);
                                    }
                                } },
                            '\u786E\u5B9A'
                        ),
                        _react2.default.createElement(
                            _reactBootstrap.Button,
                            { size: 'sm', onClick: function onClick() {
                                    _this8.close();
                                    if (typeof _this8.callback === 'function') {
                                        _this8.callback(0);
                                    }
                                }, theme: 'secondary' },
                            '\u53D6\u6D88'
                        )
                    );
                    break;
                default:
                    return null;
            }

            return _react2.default.createElement(
                'div',
                { className: 'modal-footer' },
                content
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var _this9 = this;

            var modalIndex = { zIndex: BaseModal + this.offsetIndex + 2 };
            var shadowIndex = { zIndex: BaseModal + this.offsetIndex + 1 };
            return _react2.default.createElement(
                'div',
                { ref: function ref(c) {
                        return _this9._main = c;
                    }, className: this.getMainClasses() },
                _react2.default.createElement('div', { ref: function ref(c) {
                        return _this9._shadow = c;
                    }, className: this.getShadowClasses(), style: shadowIndex, id: this.domId + '-shadow' }),
                _react2.default.createElement(
                    'div',
                    { className: this.getClasses(), style: modalIndex, tabIndex: '-1', id: this.domId, role: 'dialog' },
                    _react2.default.createElement(
                        'div',
                        { ref: function ref(c) {
                                return _this9._dialog = c;
                            }, className: this.getDialogClasses(), style: { maxWidth: this.props.width }, role: 'document' },
                        _react2.default.createElement(
                            'div',
                            { className: 'modal-content' },
                            this.state.header ? _react2.default.createElement(
                                'div',
                                { className: 'modal-header' },
                                _react2.default.createElement(
                                    'h5',
                                    { className: 'modal-title' },
                                    this.state.title
                                ),
                                this.state.isCloseBtn ? _react2.default.createElement(
                                    'button',
                                    { type: 'button', className: 'close', onClick: function onClick() {
                                            _this9.close();
                                        } },
                                    _react2.default.createElement(
                                        'span',
                                        { 'aria-hidden': 'true' },
                                        '\xD7'
                                    )
                                ) : null
                            ) : null,
                            _react2.default.createElement(
                                'div',
                                { className: 'modal-body' },
                                this.state.type === ModalLoading ? _react2.default.createElement(
                                    _react2.default.Fragment,
                                    null,
                                    _react2.default.createElement(_reactBootstrap.Load, null),
                                    '\xA0\xA0\xA0',
                                    this.state.content
                                ) : this.state.content
                            ),
                            this.renderFooter()
                        )
                    )
                )
            );
        }
    }]);

    return WModal;
}(_react2.default.Component);

WModal.propTypes = {
    onOpen: _propTypes2.default.func,
    onClose: _propTypes2.default.func,
    center: _propTypes2.default.bool,
    fade: _propTypes2.default.bool,
    blurSelector: _propTypes2.default.string,
    width: _propTypes2.default.string
};

WModal.defaultProps = {
    center: false,
    width: '300px',
    fade: true
};

exports.default = WModal;
//# sourceMappingURL=WModal.js.map
