/* @clake/react-bootstrap4-window v0.1.8 | by Clake
 * Copyright (c) 2019 Clake,
 * 2019-04-26T19:44:48+0800
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

require('./css/Window.less');

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Drag = require('./Drag');

var _Drag2 = _interopRequireDefault(_Drag);

var _IconButton = require('./IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _reactBootstrap = require('@clake/react-bootstrap4');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Window = function (_React$PureComponent) {
    _inherits(Window, _React$PureComponent);

    function Window(props) {
        _classCallCheck(this, Window);

        var _this = _possibleConstructorReturn(this, (Window.__proto__ || Object.getPrototypeOf(Window)).call(this, props));

        _this.close = function () {
            if (_this.is_before) {
                _this.beforeCloseHandler(_this.hide);
                return;
            }
            _this.hide();
        };

        _this.hide = function () {
            _this.max(false);
            _this.dom.style.top = 0;
            _this.dom.style.left = 0;
            _this.dom.classList.add('d-none');
            _this.setActive(false);
            _this.is_max = false;
            if (_this.parent) {
                _this.parent.removeWindowOpens(_this.props.name);
            }
            _this.setState({
                close: true
            }, function () {
                _this.closeHandler();
            });
        };

        _this.maxHandler = function (e) {
            _this.trigger(EVT_MAX_WINDOW, e);
            _this.max(!_this.is_max);
        };

        _this.showHandler = function (e) {
            _this.trigger(EVT_SHOW, e);
        };

        _this.closeHandler = function (e) {
            _this.trigger(EVT_CLOSE, e);
            _this.clearEvent();
        };

        _this.beforeCloseHandler = function (e) {
            _this.trigger(EVT_BEFORE_CLOSE, e);
        };

        _this.state = {
            close: true
        };
        _this.parent = _this.props.parent || null;
        _this.data = null;
        _this.evts = {};
        _this.is_before = false;
        _this.is_max = false;
        _this.max_position = {};
        return _this;
    }

    _createClass(Window, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            this.drag = new _Drag2.default(this.dragDom, this.domHeader, {
                start: function start() {
                    if (_this2.is_max) return;
                    _this2.dragDom.style.top = _this2.dom.style.top;
                    _this2.dragDom.style.left = _this2.dom.style.left;
                    _this2.dragDom.classList.remove('d-none');
                    _this2.dom.classList.add('ck-window-opacity');
                    return true;
                },
                move: function move(_move) {
                    if (_move.y < _this2.props.marginTop) {
                        _move.y = _this2.props.marginTop;
                    }
                },
                end: function end() {
                    _this2.dragDom.classList.add('d-none');
                    _this2.dom.classList.remove('ck-window-opacity');
                    _this2.dom.style.top = _this2.dragDom.style.top;
                    _this2.dom.style.left = _this2.dragDom.style.left;
                    return true;
                }
            });
            if (this.parent) {
                this.dom.addEventListener('mousedown', function (e) {
                    _this2.parent.changeWindowIndex(_this2.props.name);
                }, false);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.drag.unbind();
            this.drag = null;
        }
    }, {
        key: 'show',
        value: function show(option) {
            var _this3 = this;

            option = option || {
                x: 20,
                y: 20
            };
            this.params = option.params || null;
            this.dom.classList.remove('d-none');
            this.move(option.x, option.y);
            this.setState({
                close: false
            }, function () {
                _this3.showHandler(null);
            });
        }
    }, {
        key: 'move',
        value: function move(x, y) {
            this.dom.style.top = y + this.props.marginTop + 'px';
            this.dom.style.left = x + 'px';
        }
    }, {
        key: 'max',
        value: function max(flag) {
            if (flag) {
                this.max_position.y = this.dom.style.top;
                this.max_position.x = this.dom.style.left;
                this.max_position.width = this.dom.style.width;
                this.max_position.height = this.dom.style.height;
                this.dom.style.top = this.props.marginTop + 'px';
                this.dom.style.left = '0';
                this.dom.style.right = '0';
                this.dom.style.bottom = '0';
                this.dom.style.width = 'unset';
                this.dom.style.height = 'unset';
                this.is_max = true;
            } else {
                this.dom.style.width = this.max_position.width;
                this.dom.style.height = this.max_position.height;
                this.dom.style.top = this.max_position.y;
                this.dom.style.left = this.max_position.x;
                this.dom.style.right = 'unset';
                this.dom.style.bottom = 'unset';
                this.is_max = false;
            }
        }
    }, {
        key: 'setIndex',
        value: function setIndex(index) {
            this.dom.style.zIndex = index;
        }
    }, {
        key: 'setActive',
        value: function setActive(active) {
            if (active) {
                this.dom.classList.add('ck-window-active');
            } else {
                this.dom.classList.remove('ck-window-active');
            }
        }
    }, {
        key: 'getPosition',
        value: function getPosition() {
            return _reactBootstrap.Common.GetDomXY(this.dom);
        }
    }, {
        key: 'on',
        value: function on(fn_name, fn) {
            this.evts[fn_name] = fn;
        }
    }, {
        key: 'off',
        value: function off(fn_name) {
            this.evts[fn_name] = undefined;
        }
    }, {
        key: 'trigger',
        value: function trigger(fn_name, val) {
            if (typeof this.evts[fn_name] === 'function') {
                this.evts[fn_name](val);
            }
        }
    }, {
        key: 'clearEvent',
        value: function clearEvent() {
            this.evts = {};
        }
    }, {
        key: 'getClasses',
        value: function getClasses() {
            var base = 'card ck-window shadow d-none';
            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'getStyles',
        value: function getStyles(shadow) {
            var base = {
                width: "600px",
                height: "400px",
                top: '20px',
                left: '20px'
            };
            if (this.props.width) {
                base.width = this.props.width;
            }
            if (this.props.height) {
                var reg = /(\d+)(px|rem|pt|cm|mm)/;
                var match = this.props.height.match(reg);
                base.height = 35 + parseInt(match[1]) + match[2];
            }
            if (this.props.x) {
                base.left = this.props.x;
            }
            if (this.props.y) {
                base.top = this.props.y;
            }
            if (this.props.backColor && !shadow) {
                base.backgroundColor = this.props.backColor;
            }
            return base;
        }
    }, {
        key: 'render',
        value: function render() {
            var _this4 = this;

            var content = _react2.default.createElement(
                _react2.default.Fragment,
                null,
                _react2.default.createElement(
                    'div',
                    { ref: function ref(c) {
                            return _this4.dom = c;
                        }, className: this.getClasses(), style: this.getStyles() },
                    _react2.default.createElement(
                        'div',
                        { ref: function ref(c) {
                                return _this4.domHeader = c;
                            }, onDoubleClick: this.maxHandler, className: 'card-header' },
                        this.props.title,
                        _react2.default.createElement(
                            'div',
                            { className: 'window-btn' },
                            _react2.default.createElement(_IconButton2.default, { className: 'mr-1', iconType: 'regular', icon: 'window-maximize', onClick: this.maxHandler }),
                            _react2.default.createElement(_IconButton2.default, { icon: 'window-close', onClick: this.close })
                        )
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'card-body' },
                        !this.state.close ? this.renderContent() : null
                    )
                ),
                _react2.default.createElement('div', { ref: function ref(c) {
                        return _this4.dragDom = c;
                    }, className: 'ck-window-drag-box d-none border border-secondary', style: this.getStyles(true) })
            );

            return _reactDom2.default.createPortal(content, document.body);
        }
    }, {
        key: 'renderContent',
        value: function renderContent() {
            var _this5 = this;

            return _react2.default.Children.map(this.props.children, function (child) {
                return _react2.default.cloneElement(child, _extends({}, child.props, { parent: _this5 }));
            });
        }
    }, {
        key: 'renderEmpty',
        value: function renderEmpty() {
            return null;
        }
    }]);

    return Window;
}(_react2.default.PureComponent);

Window.propTypes = {
    title: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    x: _propTypes2.default.string,
    y: _propTypes2.default.string,
    backColor: _propTypes2.default.string,
    name: _propTypes2.default.string,
    parent: _propTypes2.default.any,
    marginTop: _propTypes2.default.any
};

Window.defaultProps = {
    marginTop: 0
};

var EVT_RESIZE = 'resize';
var EVT_MAX_WINDOW = 'max_window';
var EVT_SHOW = 'show';
var EVT_CLOSE = 'close';
var EVT_BEFORE_CLOSE = 'before_close';

Window.EVT_RESIZE = EVT_RESIZE;
Window.EVT_MAXWINDOW = EVT_MAX_WINDOW;
Window.EVT_SHOW = EVT_SHOW;
Window.EVT_CLOSE = EVT_CLOSE;
Window.EVT_BEFORE_CLOSE = EVT_BEFORE_CLOSE;

exports.default = Window;
//# sourceMappingURL=Window.js.map
