/* @clake/react-bootstrap4-window v0.1.8 | by Clake
 * Copyright (c) 2019 Clake,
 * 2019-04-26T19:44:48+0800
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defIndex = 100;

var WindowGroup = function (_React$Component) {
    _inherits(WindowGroup, _React$Component);

    function WindowGroup(props) {
        _classCallCheck(this, WindowGroup);

        var _this = _possibleConstructorReturn(this, (WindowGroup.__proto__ || Object.getPrototypeOf(WindowGroup)).call(this, props));

        _this.state = {
            showWindows: []
        };
        //ref window components
        _this.windows = {};
        //opened window list
        _this.opens = [];
        //windows
        _this.windowList = {};
        //current active window
        _this.currentActive = null;

        _react2.default.Children.map(_this.props.children, function (item) {
            _this.windowList[item.props.name] = item;
        });
        return _this;
    }

    _createClass(WindowGroup, [{
        key: 'componentDidMount',
        value: function componentDidMount() {}

        /**
         * open window
         * @param name string
         * @param params object
         */

    }, {
        key: 'open',
        value: function open(name, params) {
            var _this2 = this;

            if (this.currentActive) {
                this.windows[this.currentActive].setActive(false);
                this.currentActive = name;
            }
            if (this.opens.indexOf(name) !== -1) {
                this.changeWindowIndex(name);
                this.windows[name].show({
                    params: params
                });
                return;
            }

            if (this.windowList[name]) {
                if (this.state.showWindows.indexOf(name) !== -1) {
                    this.show(name, params);
                    return;
                }
                var showWindows = this.state.showWindows;
                showWindows.push(name);
                this.setState({
                    showWindows: showWindows
                }, function () {
                    _this2.show(name, params);
                });
            }
        }
    }, {
        key: 'show',
        value: function show(name, params) {
            var option = {
                x: this.opens.length * 20 + 10,
                y: this.opens.length * 20 + 10,
                params: params
            };
            this.windows[name].show(option);
            this.opens.push(name);
            this.changeWindowIndex(name);
        }
    }, {
        key: 'changeWindowIndex',
        value: function changeWindowIndex(name) {
            var _this3 = this;

            if (this.currentActive) {
                this.windows[this.currentActive].setActive(false);
                this.currentActive = name;
            }
            this.opens.splice(this.opens.indexOf(name), 1);
            this.opens.push(name);
            this.opens.forEach(function (key, index) {
                _this3.windows[key].setActive(key === name);
                _this3.windows[key].setIndex(defIndex + index);
            });
        }
    }, {
        key: 'removeWindowOpens',
        value: function removeWindowOpens(name) {
            var _this4 = this;

            this.opens.splice(this.opens.indexOf(name), 1);
            this.opens.forEach(function (key, index) {
                _this4.windows[key].setIndex(defIndex + index);
            });
            // let showWindows = this.state.showWindows.slice(0);
            // showWindows.splice(showWindows.indexOf(name),1);
            // this.setState({
            //     showWindows: showWindows,
            // });
        }
    }, {
        key: 'close',
        value: function close(name) {
            if (this.windows[name]) {
                this.windows[name].close();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this5 = this;

            return this.state.showWindows.map(function (name) {
                var item = _this5.windowList[name];
                item.props.parent = _this5;
                item.props.ref = function (c) {
                    return _this5.windows[name] = c;
                };
                return _react2.default.cloneElement(item, item.props);
            });
        }

        // render() {
        //     return React.Children.map(this.props.children,(item)=>{
        //         item.props.parent = this;
        //         item.props.ref = c=>this.windows[item.props.name]=c;
        //         return React.cloneElement(item,item.props,item.props.children);
        //     })
        // }

    }]);

    return WindowGroup;
}(_react2.default.Component);

WindowGroup.propTypes = {};

WindowGroup.defaultProps = {};

exports.default = WindowGroup;
//# sourceMappingURL=WindowGroup.js.map
